/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.glassfish.owb.service.impl;

import com.glassfish.owb.dao.JPADao;
import com.glassfish.owb.service.BaseService;
import java.io.Serializable;
import java.lang.reflect.ParameterizedType;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

/**
 *
 * @author rmpestano Dec 11, 2011 11:58:44 AM
 */
public class BaseServiceImpl <T, K extends Serializable> implements BaseService<T, K> {
    
    @Inject
    private JPADao<T, K> dao;


    @PostConstruct
    public void setPersistentClass() {
        dao.setPersistentClass((Class<T>) ((ParameterizedType) getClass().getGenericSuperclass()).getActualTypeArguments()[0]);
    }

    public CriteriaBuilder getCriteriaBuilder() {
        return dao.getCriteriaBuilder();
    }

    public CriteriaQuery getCriteriaQuery() {
        return dao.getCriteriaQuery();
    }

    public TypedQuery getTypedQuery() {
        return dao.getTypedQuery();
    }

    public TypedQuery getTypedQuery(CriteriaQuery criteria) {
        return dao.getTypedQuery(criteria);
    }

    public Root getRoot() {
        return dao.getRoot(getCriteriaQuery());
    }
    @Override
    public EntityManager getEntityManager(){
        return dao.getEntityManaer();
    }

    @Override
    public JPADao<T, K> getDao() {
        return dao;
    }

    @Override
    public List<T> findAll() {
        return getDao().findAll();
    }

    @Override
    public Long count() {
         TypedQuery<T> q = getEntityManager().createQuery(getCriteriaQuery().select(getCriteriaBuilder().count(getRoot())));
   	 return ((Long) q.getSingleResult());
    }
    
}
